﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace NLScC.Command
{

    public static class ManagedCommands
    {
        public static ICommand OpenMemberAdministrationCommand { get; set; }
        public static ICommand OpenPhonebookCutterCommand { get; set; }

        static ManagedCommands()
        {
            OpenMemberAdministrationCommand = new RelayCommand(OpenMemberAdministrationExecute);
            OpenPhonebookCutterCommand = new RelayCommand(OpenPhonebookCutter);
        }

        private static void OpenPhonebookCutter(object obj)
        {
            Microsoft.Win32.OpenFileDialog dialog = new Microsoft.Win32.OpenFileDialog()
            {
                Filter = "Text-File|*.txt",
                InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory),
                Title = "PhonebookCutter - Datei auswählen"
            };
            if (dialog.ShowDialog() == true)
            {
                NLScC.model.PhoneEntryCollection collection = NLScC.FileConverter.PhonebookCutter.ConvertTextFileToPhonebookCollection(dialog.FileName);
                NLScC.model.Writer.WriteFile(NLScC.model.AppSettings.PhonebookTeamPath, collection, "phone");
            }
        }

        private static void OpenMemberAdministrationExecute(object obj)
        {
            NLScC.dialog.MemberAdministrationDialog dialog = new dialog.MemberAdministrationDialog()
            {
                Owner = MainWindow.AppReference,
                Top = MainWindow.AppReference.Top + 10,
                Left = MainWindow.AppReference.Left + 30,
                FontSize = MainWindow.AppReference.FontSize,
                FontFamily = MainWindow.AppReference.FontFamily
            };
            dialog.ShowDialog();
        }

    }
}
