﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using NLScC.model;

namespace NLScC.ViewModel
{
    public class PhonebookViewModel
    {
        private PhoneEntryCollection _phonebookEntries;
        private ListCollectionView _phonebookView;
        public ListCollectionView PhonebookView
        {
            get { return _phonebookView; }
        }


        public PhonebookViewModel()
        {
            _phonebookEntries = new PhoneEntryCollection();
            LoadPhonebook();
            //LoadTestData();
            _phonebookView = new ListCollectionView(_phonebookEntries);
        }

        private void LoadPhonebook()
        {
            if (System.IO.File.Exists(AppSettings.PhonebookFilePath))
            {

                try
                {
                    for (int i = 0; i < 50000; i++)
                    {
                        _phonebookEntries.Add(new PhonebookEntry("Name " + i, "Vorname " + i * i, "Company", "Unit", "0192192" + i, "", "", "", "", "Straßenname " + i, "", "", "", "", ""));
                    }
                    //    PhoneEntryCollection c= (PhoneEntryCollection)Reader.ReadFile(AppSettings.PhonebookFilePath, _phonebookEntries, "phonebook");
                    //    foreach(PhonebookEntry e in c)
                    //    {
                    //        _phonebookEntries.Add(e);
                    //    }

                }
                catch (Exception e)
                {
                    string message = "Beim Einlesen des Telefonbuchs ist ein schwerer Fehler aufgetreten. Bitte diesen Umstand mit folgender Fehlermeldung melden: " + Environment.NewLine + e.Message;
                    LogConsole.LogLevel lvl = LogConsole.LogLevel.Error;
                    if (LogConsole.Logger != null)
                    {
                        LogConsole.Logger.Log(message, lvl);
                    }
                    else
                    {
                        LogConsole.ErrorList.Add(new LogConsole.Errors(message, lvl));
                    }
                }
            }
            else
            {
                string message = "Die Offline-Kopie des Telefonbuchs ist nicht vorhanden. Erwägen Sie einen manuellen Updatevorgang und starten Sie danach das Programm neu";
                LogConsole.LogLevel lvl = LogConsole.LogLevel.Warning;
                if (LogConsole.Logger != null)
                {
                    LogConsole.Logger.Log(message, lvl);
                }
                else
                {
                    LogConsole.ErrorList.Add(new LogConsole.Errors(message, lvl));
                }
            }
        }



        private void FillPhonebook()
        {

        }

        private void LoadTestData()
        {
            _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon AG", "NTSR", "0170 3698413", "", "", "", "", "Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy2", "Vorname", "Avacon AG", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy3", "Vorname", "Avacon AG", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy4", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy5", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("Shlumpi", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("Kocki", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("Impu", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("Tzuni", "Hans", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "G918", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("KaiCho", "Jörg", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "P31931", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("Loppi", "Kopp", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "D120821", "test@mail", "Großer Mann"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Lutschi", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "U18122", "test@mail", "Kleiner Mann"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "O827176", "test@mail", "Dicker Mann"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T1321", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "BU", "0170 35984531", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "KI", "0170 33338844", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "OP", "0176 0654641", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "OP", "080080660851", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "OP", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
           _phonebookEntries.Add(new PhonebookEntry("TestDummy", "Vorname", "Avacon Netz GmbH", "NTSR", "0192 82172151", "","","","","Watenstedter Weg 75", "Salzgitter", "Deutschland", "T29187", "test@mail", "TestSupervisor"));
        }
    }
}
